#include "StdAfx.h"
#include "UrlCode.h"
// #include "Utilities.h"

CUrlCode::CUrlCode(void)
{
}

CUrlCode::~CUrlCode(void)
{
}

inline BYTE toHex(const BYTE &x)
{
	return x > 9 ? x + 55 : x + 48;
}

inline BYTE toByte(const BYTE &x)
{
	return x > 57 ? x - 55 : x - 48;
}

CString CUrlCode::UrlDecode(CString sIn)
{
#ifdef UNICODE
	USES_CONVERSION;
#endif
	
	CStringA sInANSI;
#ifdef UNICODE
	sInANSI = W2A(sIn);
#else
	sInANSI = sIn;
#endif
	
	const int nLen = sInANSI.GetLength() + 1;
	register LPBYTE pInTmp = NULL;
	LPBYTE pInBuf = (LPBYTE)sInANSI.GetBuffer(nLen);
	
	//alloc out buffer
	CStringA sOutANSI;
	register LPBYTE pOutTmp = NULL;
	LPBYTE pOutBuf = NULL;
	pOutBuf = (LPBYTE)sOutANSI.GetBuffer(nLen);
	
	if (pOutBuf)
	{
		pInTmp   = pInBuf;
		pOutTmp = pOutBuf;
		// do encoding
		while (*pInTmp)
		{
			if ('%' == *pInTmp)
			{
				pInTmp++;
				*pOutTmp++ = (toByte(*pInTmp) % 16 << 4) + toByte(*(pInTmp + 1)) % 16;//4λ+4λ
				pInTmp++;
			}
			else if ('+' == *pInTmp)
				*pOutTmp++ = ' ';
			else
				*pOutTmp++ = *pInTmp;
			pInTmp++;
		}
		*pOutTmp = '\0';
		sOutANSI.ReleaseBuffer();
	}
	sInANSI.ReleaseBuffer();
	
#ifdef UNICODE
	return A2W(sOutANSI);
#else
	return sOutANSI;
#endif
}

CString CUrlCode::UrlEncode(CString sIn)
{
#ifdef UNICODE
	USES_CONVERSION;
#endif
	
	CStringA sInANSI;
#ifdef UNICODE
	sInANSI = W2A(sIn);
#else
	sInANSI = sIn;
#endif
	
	const int nLen = sInANSI.GetLength() + 1;
	register LPBYTE pInTmp = NULL;
	LPBYTE pInBuf = (LPBYTE)sInANSI.GetBuffer(nLen);
	
	//alloc out buffer
	CStringA sOutANSI;
	LPBYTE pOutBuf = NULL;
	register LPBYTE pOutTmp = NULL;
	pOutBuf = (LPBYTE)sOutANSI.GetBuffer(nLen * 3);
	
	if (pOutBuf)
	{
		pInTmp   = pInBuf;
		pOutTmp = pOutBuf;
		// do encoding
		while (*pInTmp)
		{
			if (isalnum(*pInTmp) || '-' == *pInTmp || '_' == *pInTmp || '.' == *pInTmp)
				*pOutTmp++ = *pInTmp;
			else if (isspace(*pInTmp))
				*pOutTmp++ = '+';
			else
			{
				*pOutTmp++ = '%';
				*pOutTmp++ = toHex(*pInTmp >> 4);//4λ
				*pOutTmp++ = toHex(*pInTmp % 16);//4λ
			}
			pInTmp++;
		}
		*pOutTmp = '\0';
		sOutANSI.ReleaseBuffer();
	}
	sInANSI.ReleaseBuffer();
#ifdef UNICODE
	return A2W(sOutANSI);
#else
	return sOutANSI;
#endif
}

