#include "StdAfx.h"
#include ".\wlanhttprequest.h"
#include "WlanControlDlg.h"
#include "UrlCode.h"
#include <sys/timeb.h>
#include "WlanControl.h"

void CHttpRequest::ResetUrlOption()
{
	curl_easy_reset(m_pUrlHandle);

	//ԶHttp HeaderеReferer
	curl_easy_setopt(m_pUrlHandle,CURLOPT_AUTOREFERER,1);

	curl_easy_setopt(m_pUrlHandle,CURLOPT_TIMEOUT_MS,5000);
	curl_easy_setopt(m_pUrlHandle,CURLOPT_CONNECTTIMEOUT_MS,2000);

	//curl_easy_setopt(m_pUrlHandle,CURLOPT_VERBOSE,1);

	//Header
	curl_easy_setopt(m_pUrlHandle,CURLOPT_HEADER,1);

	//ôm_pUrlHandleCookie(Զ,ύHttp HeaderеCookie)
	curl_easy_setopt(m_pUrlHandle,CURLOPT_COOKIEFILE,"");

	//DNSʱʱ 1
	curl_easy_setopt(m_pUrlHandle, CURLOPT_DNS_CACHE_TIMEOUT, 1);  

	curl_easy_setopt(m_pUrlHandle, CURLOPT_NOPROGRESS, 1); 
	curl_easy_setopt(m_pUrlHandle, CURLOPT_BUFFERSIZE, 1024*1024*5); 

	curl_easy_setopt(m_pUrlHandle, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; Trident/4.0; Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1) ; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; SE 2.X MetaSr 1.0)");

	//öȡݵĻص
	curl_easy_setopt(m_pUrlHandle, CURLOPT_WRITEFUNCTION, write_data);

	//m_strHtmlָ봫ݸwrite_data(void *userpm_strHtmlָ)
	curl_easy_setopt(m_pUrlHandle, CURLOPT_WRITEDATA, &m_strHtml);
}

CHttpRequest::CHttpRequest(void)
{
	m_pUrlHandle=curl_easy_init();
	iRequestCount=AfxGetApp()->GetProfileInt("Debug","iRequestCount",0);
}

CHttpRequest::~CHttpRequest(void)
{
	AfxGetApp()->WriteProfileInt("Debug","iRequestCount",iRequestCount);
	curl_easy_cleanup(m_pUrlHandle);
}


CHttpRequestWlan::CHttpRequestWlan( CWlanControlDlg* pDlg )
{
	m_pDlg=pDlg;
}


size_t CHttpRequest::write_data(void *buffer, size_t size, size_t nmemb, void *userp)
{
	size_t nsize=size*nmemb;

	string *strHtml=(string*)userp;
	strHtml->append((char*)buffer,nsize);

	return nsize;
}

string& CHttpRequest::Post(string strUrl,string strData,string sRefer)
{
	ResetUrlOption();

	m_strHtml="";
	if(!sRefer.empty())
	{
		curl_easy_setopt(m_pUrlHandle,CURLOPT_REFERER, sRefer.c_str());	
	}
	curl_easy_setopt(m_pUrlHandle,CURLOPT_URL, strUrl.c_str());
	curl_easy_setopt(m_pUrlHandle,CURLOPT_POSTFIELDS,strData.c_str());
	CURLcode res = curl_easy_perform(m_pUrlHandle);
	write_debugInfo("POST:\""+strUrl+"\"\r\n\""+strData+"\"\r\n"+m_strHtml);
	return m_strHtml;
}

string& CHttpRequest::Get(string strUrl)
{
	ResetUrlOption();

	m_strHtml="";
	curl_easy_setopt(m_pUrlHandle,CURLOPT_URL, strUrl.c_str());
	CURLcode res = curl_easy_perform(m_pUrlHandle);
	//TRACE("#####:\n%s",m_strHtml.c_str());
	write_debugInfo("GET:\""+strUrl+"\"\r\n"+m_strHtml);
	return m_strHtml;
}

void CHttpRequest::write_debugInfo(string& s)
{
	iRequestCount++;

	BOOL bSave=(BOOL)AfxGetApp()->GetProfileInt("Debug","bSaveRequestLog",0);
	if (bSave)
	{
		char sztext[100];
		sprintf_s(sztext,"http_request_%02d.log",iRequestCount);

		CFile f;
		f.Open(sztext,CFile::modeCreate|CFile::modeWrite|CFile::typeBinary);
		f.Write(s.c_str(),(UINT)s.length());
		f.Close();
	}
}


CString GetCurrentSysTime(BOOL bUseMillitm)
{
	CTime now = CTime::GetCurrentTime();
	CString cs_time = now.Format("%H:%M:%S");

	if (bUseMillitm)
	{
		_timeb t;
		_ftime_s(&t);
		CString cs_millitm;
		cs_millitm.Format("%03d ", t.millitm);
		return cs_time + "." + cs_millitm;
	}
	else
	{
		return cs_time;
	}
}

bool CHttpRequestWlan::Login( string user,string pass )
{
	//1,ַȡתĵַ
	AddLog("GET:http://www.baidu.com/");
	string sHtml=Get("http://www.baidu.com/");
	if (sHtml.empty())
	{
		AddLog("GET:http://www.baidu.com/ʧ,");
		return false;
	}

	string sHost=CutString(sHtml,"<NextURL>","/bpss/login.jsp");
	string sNextUrl=CutString(sHtml,"<NextURL>","</NextURL>");
	if (sNextUrl.empty())
	{
		AddLog("޷ȡ<NextURL>");
		return false;
	}

	//2,תĵַ(ַһȡ)
	AddLog("GET:"+sNextUrl);
	sHtml=Get(sNextUrl);
	if (sHtml.empty())
	{	
		AddLog("GET:"+sNextUrl+"ʧ");
		return false;
	}

	string wlanuserip=CutString(sHtml,"NAME=\"wlanuserip\" value=\"","\">");
	string wlanacname=CutString(sHtml,"NAME=\"wlanacname\" value=\"","\">");
	string wlanacip=CutString(sHtml,"NAME=\"wlanacip\" value=\"","\">");

	//3,תԶύ
	AddLog("POST:"+sHost+"/bpss/index.jsp");
	sHtml=Post(sHost+"/bpss/index.jsp","wlanuserip="+wlanuserip+"&wlanacname="+wlanacname+"&wlanacip="+wlanacip);
	if (sHtml.empty())
	{	
		AddLog("POST:"+sHost+"/bpss/index.jspʧ");
		return false;
	}

	//4,ִе¼
	AddLog("POST:"+sHost+"/bpss/jsp/do_login.jsp");
	sHtml=Post(sHost+"/bpss/jsp/do_login.jsp","bpssUSERNAME="+user+"&bpssSMSRND="+pass);
	if (sHtml.empty())
	{
		AddLog("POST:"+sHost+"/bpss/jsp/do_login.jspʧ");
		return false;
	}

	if (sHtml.find("bpss/login.jsp")!=string::npos)
	{	
		AddLog("¼ʧ,û.");
		return false;
	}

	int iTryTimes=0;
	while(iTryTimes<10)
	{
		if (iTryTimes==0)
		{
			AddLog("߳ɹ,ڻȡ...");
		}
		else
		{
			AddLog("...");
		}

		//5,¼ɹת
		AddLog("GET:"+sHost+"/bpss/jsp/index.jsp");
		sHtml=Get(sHost+"/bpss/jsp/index.jsp");
		if (sHtml.empty())
		{
			AddLog("GET:"+sHost+"/bpss/jsp/index.jspʧ,߳ɹ޷");
			continue;
		}

		string sLogoutAction=CutString(sHtml,"name=\"loginform\" action=\"","\" method=\"post\"");
		string actiontype=CutString(sHtml,"name=\"actiontype\" value=\"","\"/>");
		string logonsessid=CutString(sHtml,"name=\"logonsessid\" value=\"","\"/>");
		wlanuserip=CutString(sHtml,"name=\"wlanuserip\" value=\"","\"/>");
		wlanacname=CutString(sHtml,"name=\"wlanacname\" value=\"","\"/>");
		string USER=CutString(sHtml,"name=\"USER\" value=\"","\"/>");
		string WLANDIG=CutString(sHtml,"name=\"WLANDIG\" value=\"","\"/>");
		string logouttype=CutString(sHtml,"name=\"logouttype\" value=\"","\"/>");

		if(sLogoutAction=="" ||
			actiontype==""||
			logonsessid==""||
			wlanuserip==""||
			wlanacname==""||
			USER==""||
			WLANDIG==""||
			logouttype=="")
		{
			AddLog("ȡʧ,߳ɹ,޷");
			continue;
		}

		CWinApp* pApp=AfxGetApp();
		AddLog("ѱ״̬.");
		pApp->WriteProfileString("Login","LoginTime",CTime::GetCurrentTime().Format("%Y-%m-%d %H:%M:%S"));
		pApp->WriteProfileString("Login","sLogoutAction",sLogoutAction.c_str());
		pApp->WriteProfileString("Login","actiontype",actiontype.c_str());
		pApp->WriteProfileString("Login","logonsessid",logonsessid.c_str());
		pApp->WriteProfileString("Login","wlanuserip",wlanuserip.c_str());
		pApp->WriteProfileString("Login","wlanacname",wlanacname.c_str());
		pApp->WriteProfileString("Login","USER",USER.c_str());
		pApp->WriteProfileString("Login","WLANDIG",WLANDIG.c_str());
		pApp->WriteProfileString("Login","logouttype",logouttype.c_str());
		pApp->WriteProfileString("Login","sHost",sHost.c_str());

		break;

		iTryTimes++;
	}

	AddLog("߳ɹ!!");
	return true;
}

void CHttpRequestWlan::AddLog(string strLog)
{
	m_pDlg->UpdateData(TRUE);
	m_pDlg->m_strLog=m_pDlg->m_strLog+GetCurrentSysTime(TRUE)+strLog.c_str()+"\r\n";
	m_pDlg->UpdateData(FALSE);
	m_pDlg->RedrawWindow();
}

bool CHttpRequestWlan::Logout()
{
	CWinApp* pApp=AfxGetApp();
	string sLogoutAction=pApp->GetProfileString("Login","sLogoutAction");
	if (sLogoutAction.empty())
	{
		sLogoutAction="http://221.179.9.18:8080/bpss/jsp/do_logout.jsp";
	}
	string actiontype=pApp->GetProfileString("Login","actiontype");
	string logonsessid=pApp->GetProfileString("Login","logonsessid");
	string wlanuserip=pApp->GetProfileString("Login","wlanuserip");
	string wlanacname=pApp->GetProfileString("Login","wlanacname");
	string USER=pApp->GetProfileString("Login","USER");
	string WLANDIG=pApp->GetProfileString("Login","WLANDIG");
	string logouttype=pApp->GetProfileString("Login","logouttype");
	string sHost=pApp->GetProfileString("Login","sHost");

	CUrlCode encode;
	CString sUrlCodeWLANDIG=encode.UrlEncode(WLANDIG.c_str());
	string sPosData="actiontype="+actiontype
					+"&logonsessid="+logonsessid
					+"&wlanuserip="+wlanuserip
					+"&wlanacname="+wlanacname
					+"&USER="+USER
					+"&WLANDIG="+sUrlCodeWLANDIG.GetBuffer()
					+"&logouttype="+logouttype;
	sUrlCodeWLANDIG.ReleaseBuffer();

	AddLog("POST:"+sLogoutAction);
	string sHtml=Post(sLogoutAction,sPosData,sHost+"/bpss/jsp/index.jsp");
	if (sHtml.empty())
	{
		AddLog("POST:"+sLogoutAction+"ʧ.");
		AddLog("޷ȷǷߣ粢Ժ!");
		return false;
	}

	string sErrorMsg=CutString(sHtml,"alert('","')");
	AddLog(sErrorMsg+"!!");

	if (sErrorMsg=="ʧܣԺԣ")
	{
		return false;
	}
	return true;
}

//YYYY-mm-dd HH:MM:SSʽʱתΪCTime
CTime CHttpRequestWlan::FromTimeString(CString pm_TimeString)
{
	int nYear=atoi(pm_TimeString.Mid(0,4));
	int nMonth=atoi(pm_TimeString.Mid(5,2));
	int nDay=atoi(pm_TimeString.Mid(8,2));
	int nHour=atoi(pm_TimeString.Mid(11,2));
	int nMin=atoi(pm_TimeString.Mid(14,2));
	int nSec=atoi(pm_TimeString.Mid(17,2));
	return CTime(nYear, nMonth, nDay, nHour, nMin, nSec);
}

bool CHttpRequestWlan::IsLogin()
{
	AddLog("⵱ǰǷ...");
	string sHtml=Get("http://www.baidu.com/");
	if (sHtml.find("ٶ")!=string::npos)
	{
		AddLog("ǰ״̬.");
		return true;
	}
	
	
	if (sHtml=="")
	{
		AddLog("޷ȷǷ״̬,硣");
		AddLog("ʱΪ״̬.");
		return false;
	}
	else
	{
		AddLog("ǰ״̬.");
	}

	return false;
}

string CHttpRequestWlan::CutString( string& str,string strLeft,string strRight )
{
	size_t npos1=str.find(strLeft);
	if (npos1==string::npos)
	{
		return "";
	}

	size_t npos2=str.find(strRight,npos1+strLeft.length());
	if (npos2==string::npos)
	{
		return str.substr(npos1+strLeft.length(),strLeft.length());
	}

	return str.substr(npos1+strLeft.length(),npos2-(npos1+strLeft.length()));
}

